
#include "tetera.h"
#include "catfun.h"
#include <time.h>
#include <math.h>

extern  double tx,ty,tz,e,
               crx,crz,angr ;

extern double mr,mg,mb ;
extern int    color_malla ;


#define rnd() ((double)random()/(double)RAND_MAX)

void color_aleatorio_1()
{
    color_malla = 1 ;

    mr = 0.9+0.2*rnd() ;
    mg = 0.8+0.1*rnd() ;
    mb = 0.8+0.2*rnd() ;
}

void genera_tetera(unsigned nu,unsigned nv)
{
   sup_bspline cuerpo, boca, asa, tapa ;

   printf("\n") ;
   printf("\n") ;
   printf("\n//**** Tetera ****\n") ;

    color_aleatorio_1() ;

   printf("\n\n// Boca:\n") ;
   crea_boca( &boca ) ;
   parametros_bspline( &boca ) ;
   genmalla( bspline, nu,nv ) ;

     color_aleatorio_1() ;

   printf("\n\n// Asa:\n") ;
   crea_asa( &asa ) ;
   parametros_bspline( &asa ) ;
   genmalla( bspline, nu,nv ) ;

     color_aleatorio_1() ;

   printf("\n\n// Tapa:\n") ;
   crea_tapa( &tapa ) ;
   parametros_bspline( &tapa ) ;
   genmalla( bspline, nu,nv ) ;

     color_aleatorio_1() ;

   printf("\n\n// Cuerpo:\n") ;
   crea_cuerpo( &cuerpo ) ;
   parametros_bspline( &cuerpo ) ;
   genmalla( bspline, nu,nv ) ;

   printf("\n\n// **** Fin Tetera  ****");
   printf("\n\n") ;
}

void muchas_teteras( unsigned nu, unsigned nv )
{


   unsigned long
       nx = 5,
       nz = 5,
       ix ,
       iz ,
       i  ;

   double wx = 10.0 ,
          wz = 10.0 ;

   double dx = (double)1.0/(double)nx ;
   double dz = (double)1.0/(double)nz ;


   for( ix=0 ; ix < nx ; ix++ )
   for( iz=0 ; iz < nz ; iz++ )
   {
       double fx = (double)ix/(double)nx ;
       double fz = (double)iz/(double)nz ;

       e = 0.7*0.25*wx*dx * (0.85+0.3*rnd());
       tx = wx*( fx + 0.4*dx*rnd() ) ;
       tz = wz*( fz + 0.4*dz*rnd() ) ;
       ty = -1.5*e ;

       crx = 0.0 ;
       crz = 0.0 ;
       angr = 2.0*M_PI*rnd() ;

       genera_tetera( nu, nv ) ;
   }



   /** generar la base: **/

   {
      unsigned long
         nub = nu*nx/2 ,
         nvb = nv*nz/2 ;

      color_malla = 1 ;
      mr = 1.0 ; mg = 0.8 ; mb = 0.8 ;

      tx = -2.0*dx ;
      tz = -2.0*dz ;
      crx = 0.0 ;
      crz = 0.0 ;
      angr = 0.0 ;
      e = (wx > wz) ? wx : wz ;


      genmalla( plano_xz, nub, nvb ) ;
   }

   /** escribir las fuentes de luz **/

   {
      int nfx= 4, nfz = 4, ix, iz ;

      for( ix = 0 ; ix < nfx ; ix++ )
      for( iz = 0 ; iz < nfz ; iz++ )
      {
         printf("\nlight");
         printf("\n   begin");

         {
            double x0,z0,dx,dz ;

            dx =  (double)wx/(double)nfx ;
            dz =  (double)wz/(double)nfz ;

            x0 = (double)ix * dx + 0.3*dx ;
            z0 = (double)iz * dz + 0.3*dz ;

            printf("\n      (%f,4.0,%f)",(float)x0,(float)z0);
            printf("\n      (%f,0,0)",(float)(0.4*dx)) ;
            printf("\n      (0,0,%f)",(float)(0.4*dz)) ;
         }

         printf("\n      rgb (%f,%f,%f)",0.8+0.2*rnd(),0.8+0.2*rnd(),0.8+0.2*rnd());

         printf("\n   end");
      }

   }
}



void cabecera(int nu, int nv)
{

   time_t fecha_actual = time(NULL)  ;


   printf("\n//********************************");
   printf("\n//");
   printf("\n// Fichero generado con 'gtpt'") ;
   printf("\n//");
   printf("\n// nu    = %d",nu);
   printf("\n// nv    = %d",nv);
   printf("\n// fecha = %s",ctime(&fecha_actual));
   printf("//");
   printf("\n//********************************");
}



int main( int argc, char * argv[] )
{
   int nu=50,nv=50, tipo = 1 ;

   if ( argc >= 1 )
   {
      tipo = atoi(argv[1]);
   }

   if ( argc >= 4 )
   {
      nu = atoi(argv[2]);
      nv = atoi(argv[3]);
   }


   cabecera(nu,nv) ;
   switch( tipo )
   {
      case 1 : genera_tetera( nu, nv ) ;
               break ;

      case 2 : genmalla( esfera, nu, nv ) ;
               break ;

      case 3 : genmalla( esfera_picos, nu, nv ) ;
               break ;

      case 4 : genmalla( caracola, nu, nv ) ;
               break ;

      case 5 : genmalla( caracola_simple, nu, nv ) ;
               break ;

      case 6 : muchas_teteras(nu, nv ) ;
               break ;

      case 7 : genmalla( ondas, nu, nv ) ;
               break ;

      case 8 : genmalla( cilindro, nu, nv ) ;
               break ;

      case 9 : genmalla( plano_xz, nu, nv ) ;
               break ;
   }
}
